#    rdotst.tcl     generic VXI Version   /vxi/tcl/cabletst.tcl
#    added the collect system cards part

global EGreport
set debug 0
set started 0
set cablereport ""
set reportreq 0
set staticstate 0
set failcount 0

set frame CABLETST
set frametitle "Resource Manager Cable Test"
set icontitle  "Cable Tst"
set testmodeset 0
set eventmemo 0
set eventrun 0
set scalercount 0
set scalerbase 0
# test information for the trigger, and the RM see the end for Trigger,and RM specific routines
set signallist { go clear scalers sync irequest iaction}
# these lists are for the current make up of the system.
set cardtype ""
set RMchanlist {}

set cardtypes { RM }
#			crate		type		channel		
set cardtable(0)	{					}
# then the number of cards in the system
set cardcount 0

# back to the copy information 

set tapestreams 1
set afterid ""
set triggerchanged 0

set vxireq 1
set ecreq 0
set datareq 0
set formatreq 0
set togglecount 0
set vxistatus 0
set vxistate 0
set ecstate 0
set datastate 0
set formatstate 0

set EGkeep 0
set EGkeep1 0
set TriggerResource VXI
loadsource common.vxi

set eventcount 1

proc starttask {task} {
#    Check if it is necessary to pre-start server interface task

    set started [inform $task inquire started]
    if {$started == 0} then {
      send $task start
      send $task close-frame
    }
}

proc click-count {v} { 
   global eventcount
	set eventcount $v
}

proc click-event {v} {
   global eventcount togglecount afterid resource triggerchanged eventmemo eventrun testmodeset
   global  reportreq staticstate cablereport failcount
	if {$v == 1 } {
		if { $eventrun == 0 } {
			set eventmemo $eventcount
			set eventrun 1
			set staticstate 0
			set failcount 0
			click-redisplay
			set-footer "$eventmemo Cable Test events still to be sent"
			if { $reportreq == 1 } { set cablereport "  Cable test report \n" }
			make-cable-test
		}
	}
	if {$v == 0 } { 
		set eventrun 0
		set triggerchanged 0
		set testmodeset 0
		after cancel $afterid 
		clear-footer
		click-redisplay
	}
}



proc sync-trig {v} {
	global resource
	EG "register :name '/$resource/TriggerMK2.VXI.Sync.Trig' :value '$v'"
}

proc click-redisplay {} {
  global staticstate failcount

   if { $failcount == 0 } {
	:modify FAILSTATE :value 0
    } \
   else {
	:modify FAILSTATE :value 1
   }
   :modify FAILCNT :value $failcount
   :modify STATICSTATE :value $staticstate
   

}


proc click arg {
	global debug
        global reportreq

	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$c==":quit"} then {click-quit; return}
	switch -glob $w {
                VXI   {click-vxi $v}
                *REQ  {
                   eval set [string tolower $w] $v
                   click-redisplay
                }

                EBGO   {click-event 1}
                EBSTOP {click-event 0}
                EVCNT  {click-count $v}

		default {puts stderr "sys:  click \{$arg\}"}
	}
}
# start up routine makes the frame.

proc start args {
   global started 
   if {$started == 0} then {make-frame} else {open-frame}
   set started 1
	get-all-cards
	make-system-image
   click-redisplay
   return
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

proc make-frame {} {
  global env scalercount 
  global reportreq
  global staticstate

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/egarray" \
      :icon-name "[self icon-title]" :resize F


   :panel PANEL2B :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :message MSG1 :label "Tests required:" :bold T :valuex 25c
         :checkbox REPORTREQ    :label "Create report" :valuex 20c  :value $reportreq

   :panel PANEL2A :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :vskip 20
       :message MSGEB  :label "Readout Tests" :bold T
       :hskip 30
       :button EBGO   :label "GO"     :w 8  :h 3 :colour green
       :button EBSTOP :label "STOP"   :w 8  :h 3 :colour red

   :panel PANEL2C :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :message MSG2 :label "Tests Complete:" :bold T :valuex 25c
         :checkbox STATICSTATE    :label "Static Test" :valuex 20c  :value $staticstate :colours "red green" :deaf T
	 :next-row T
         :checkbox FAILSTATE    :label "Tests Failed" :valuex 20c  :value $staticstate :colours "red green" :deaf T
	 :next-row T
	 :text FAILCNT	:label "Fail count" :value 0 :valuex 20c :w 5 :read-only T

   :panel PANEL3 :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :message MSGRESB :label "Test control" 
      :next-row T
      :slider EVCNT :label "Number of Tests" :min 1 :max 1000 :resolution 1
      :layout V


   :panel BUTTONS :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :next-row T
      :button REDISPLAY   :label "Redisplay"       :command click-redisplay
      :hskip 70
      :button HELP        :command click-help

   :show T
}
 
proc get-all-cards {} {
global cardtypes cardtype chanlist

	foreach w $cardtypes {
		set cardtype $w
		make-chanlist
		set l $w
		append l "chanlist"
		global $l
		set $l $chanlist
	}

}
# set up the system table as a collection of lists of cards, and where they are ?
proc make-system-image {} {
global cardtypes cardtype chanlist chanindex cardtable cardcount 
	set cardcount 0
	foreach w $cardtypes {
		set cardtype $w
		set l $w
		append l "chanlist"
		global $l
		foreach v [ set [ set l ] ] {
			if { $v != "???" } {
				set cardtable($cardcount) [ VXImodule2crate $cardtype$v ]
				append cardtable($cardcount)  " $cardtype $v"
				incr cardcount
			}
		}
	}
}
# Use the table of cards to run the test.
proc make-d2vb-registers {} {
global D2VBserver
	foreach v { file dump go stop init count clear } {
		set l dvtest_
		append l $v
		if { [ ersinquire $D2VBserver $l ] == "" } {
			ersdefine $D2VBserver $l generic
		}
	}
	erswta	$D2VBserver dvtest_file { -n dvtest_file -t string }
	erswta	$D2VBserver dvtest_clear { -n dv_clear -t function }
	erswta	$D2VBserver dvtest_dump { -n dv_dump -t function }
	erswta	$D2VBserver dvtest_go { -n dvgo -t function }
	erswta	$D2VBserver dvtest_stop { -n dvstop -t function }
	erswta	$D2VBserver dvtest_init { -n dvinit -t function }
	erswta	$D2VBserver dvtest_count { -n dvtest_count -t int }
	EG "register :name '/$D2VBserver/dvtest_file' :value '/MIDAS/rdotst/dump' "
}


proc make-cable-test {} {
global cardtable cardcount togglecount   eventmemo eventrun afterid EGkeep1 EGreport
global reportreq signallist staticstate cablereport
	set EGkeep1 $EGreport
	set EGreport -1
	set eventmemo [expr {$eventmemo -1 }]
	for { set n 0 } { $n < $cardcount } { incr n } {
		set lcardtype [ lindex $cardtable($n) 1 ]
		set lresource [ lindex $cardtable($n) 0 ]
		set lchan     [ lindex $cardtable($n) 2 ]
		foreach v $signallist {
			test-signal $lresource $lchan $v
		}
	}
	set EGreport $EGkeep1
	if {$eventmemo == 0  } then {
		if { $reportreq == 1 } { 
			append cablereport " Cable test [ expr $eventmemo + 1 ] completed \n" 
			midas-information $cablereport
		}
		set staticstate 1
		set eventrun 0
		clear-footer
		click-redisplay
	} \
	else	{
		if { $reportreq == 1 } { append cablereport " Cable test [ expr $eventmemo + 1 ] completed \n" }
		set-footer "$eventmemo Cable Test events still to be sent"
		set afterid [ after 20 make-cable-test ]
	}
	
}
proc report-fault { resource chan signal message } { 
global cablereport reportreq failcount
	switch $signal {
		go    { set w "VXI Go" }
		clear { set w "VXI Clear" }
		scalers { set w "Transfer Scalers" }
		iaction { set w "Inhibit Action" }
		sync    { set w "Sync Trig" }
		irequest { set w "Inhibit Request" }
		logic0  { set w "Logic Inspection Line 0" }
		logic1  { set w "Logic Inspection Line 1" }
	}
	incr failcount
	if { $reportreq == 1 } {
		append cablereport "$message $w in RM$chan at $resource \n"
	}
}

proc test-signal { resource chan v } {

	switch $v {
		go -
		clear -
		scalers -
		sync  {
			set-trigger-signal  $v 1
			set n [ measure-rm-signal $resource $chan $v ]
			if { $n != 1 } {
				report-fault $resource $chan $v "Failed to set "
			}
			set-trigger-signal  $v 0
			set n [ measure-rm-signal $resource $chan $v ]
			if { $n != 0 } {
				report-fault $resource $chan $v "Failed to clear "
			}
		}
		irequest -
		iaction  {
			set-rm-signal $resource $chan irequest 1
			set n [ measure-rm-signal $resource $chan iaction ]
			if { $n != 1 } {
				report-fault $resource $chan $v "Failed to set "
			}
			set-rm-signal $resource $chan irequest 0
			set n [ measure-rm-signal $resource $chan $v ]
			if { $n != 0 } {
				report-fault $resource $chan $v "Failed to clear "
			}
		}
		default {
			report-fault $resource $chan $v "Unknown signal to be tested "
		}
	}
}			
			
proc ersdefine {server register class} {
   EG "register :name '/$server/$register' :class '$class' !new"
}
proc erswrite { server register v } {
   EG "register :name '/$server/$register' :value '$v' "
}
proc ersinquire {server register} {
   EG "register :pattern '/$server/$register' ?names"
}

proc erswta {server register args} {
   EG "register  :name '/$server/$register' :object '$args'"
}
proc ersread { server register } {
   EG "register :name '/$server/$register' ?value "
}

# Resource Manager specific test signal routine
# returns the value of the signal 
proc measure-rm-signal { resource chan signal } {
	switch $signal {
		go -
		clear -
		iaction -
		scalers { 
			set v  [ ersread $resource RM$chan.TTLTRG ] 
		}
		sync -
		irequest -
		logic0 -
		logic1 {
			set v  [ ersread $resource RM$chan.ECLTRG ] 
		}
	}
	return [ rm-trg-decode $signal $v ] 
}
proc rm-trg-decode { signal v } {
	switch $signal {
		go    { set w 0x10 }
		clear { set w 0x08 }
		scalers { set w 0x04 }
		iaction { set w 0x80 }
		sync    { set w 0x02 }
		irequest { set w 0x04 }
		logic0  { set w 0x08 }
		logic1  { set w 0x10 }
	}
	if {  [ expr $v & $w ] == $w } { return 1 } else { return 0 }

}			
proc set-rm-signal { resource chan signal v } {
	switch $signal {
		irequest { return [ erswrite $resource RM$chan.VXI.Inhibit $v ] }
		default {}
	}
}

# TriggerMK2 specific routines to set signals.
proc set-trigger-signal {  signal v } {
global TriggerResource
	switch $signal {
		go { return [erswrite $TriggerResource TriggerMK2.VXI.Go $v ] }
		clear { return [erswrite $TriggerResource TriggerMK2.VXI.Clear $v ] }
		scalers { return [erswrite $TriggerResource TriggerMK2.XferScalers $v ] }
		sync { return [erswrite $TriggerResource TriggerMK2.VXI.Sync.Trig $v ] }
		default {}
	}
}

