

#  essdefn.tcl     ESS VXI card

proc {AddESSModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   ESSVXIRegisters $slot
   ESSModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {
        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        ess_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"
   
        ESSVXIRegisters $slot
        ESSModuleRegisters $slot

        ESSDetectorRegisters $slot $socket

   }

}


proc ess_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc ESSVXIRegisters {slot} {

   ess_register  datal          xDig "-s$slot -o0x0 -w32 -prw -fx"
   ess_register  dataw          xDig "-s$slot -o0x0 -w16 -prw -fx"
#   ess_register  Shtdata        xSht "-s$slot -o0x0 -w16 -prw -fx"

   ess_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   ess_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   ess_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   ess_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   ess_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   ess_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   ess_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   ess_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   ess_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   ess_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   ess_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   ess_register  VXI.Control    xSht   "-s$slot -o4  -prw -w16 -fx -b0 -l0 -i0xffc0"
   ess_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   ess_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}


proc ESSModuleRegisters {slot} {
   global registerbase

#    Common Register Area

#    GIR Module Control Register
        ess_register   MCR_GIR                 xDig    "-s$slot  -o0x10 -w16 -prw -fx -b0 -l0 -i0"
        ess_register   LastCard                xDig    "-s$slot  -o0x10 -w16 -prw -fx -b0 -l1"
        ess_register   FIFO.Reset              xDig    "-s$slot  -o0x10 -w16 -prw -fx -b1 -l1"
        ess_register   DSP.Reset               xDig    "-s$slot  -o0x10 -w16 -prw -fx -b2 -l1 -i0"
        ess_register   ResetGIR               xDig    "-s$slot  -o0x10 -w16 -prw -fx -b3 -l1"
        ess_register   PROM.WP                 xDig    "-s$slot  -o0x10 -w16 -prw -fx -b4 -l1"

#    ESS Module Control Register
        ess_register   MCR_ESS                 xDig    "-s$slot -o0x12 -w16 -prw -fx -b0 -l0 -i0"
        ess_register   ESS.FIFO.Reset          xDig    "-s$slot -o0x12 -w16 -prw -fd -b0 -l1 -i1"


        ess_register   DSP.DAC.Adj             xDig "-s$slot -o0x14 -w16 -pwo -fx -b0 -l0"
        ess_register   DSP.POT.Adj             xDig "-s$slot -o0x16 -w16 -pwo -fx -b0 -l0"

#    Inspection lines
        ess_register Insp.D1.Channel   xMux "-s$slot -o0x20 -w16 -prw -b0 -l16 -dESS -md1"
        ess_register Insp.D1.Signal    xDig "-s$slot -o0x22 -w16 -prw -fd -b0 -l0 -i0"
        ess_register Insp.D2.Channel   xMux "-s$slot -o0x24 -w16 -prw -b0 -l16 -dESS -md2"
        ess_register Insp.D2.Signal    xDig "-s$slot -o0x26 -w16 -prw -fd -b0 -l0 -i0"
        ess_register Insp.A1.Channel   xMux "-s$slot -o0x28 -w16 -prw -b0 -l16 -dESS -ma1"
        ess_register Insp.A1.Signal    xDig "-s$slot -o0x2a -w16 -prw -fd -b0 -l0 -i0"
        ess_register Insp.A2.Channel   xMux "-s$slot -o0x2c -w16 -prw -b0 -l16 -dESS -ma2"
        ess_register Insp.A2.Signal    xDig "-s$slot -o0x2e -w16 -prw -fd -b0 -l0 -i0"
#        ess_register Insp.V.Channel    xMux "-s$slot -o0x30 -w16 -prw -b0 -l16 -dESS -mv"
#        ess_register Insp.V.Signal     xDig "-s$slot -o0x32 -w16 -prw -fd -b0 -l0 -i0"

#   Temperature control registers  0x40 => 0x54

        ess_register   GIR.TCR.ReadTemp 	xDig    "-s$slot  -o0x40 -w16 -pro -fx -b0 -l9"
        ess_register   GIR.TCR.WriteTempHigh 	xDig    "-s$slot  -o0x42 -w16 -pwo -fx -b0 -l9 -i0x3c"
        ess_register   GIR.TCR.WriteTempLow 	xDig    "-s$slot  -o0x44 -w16 -pwo -fx -b0 -l9 -i0x28"
        ess_register   GIR.TCR.ReadTempHigh 	xDig    "-s$slot  -o0x46 -w16 -pro -fx -b0 -l9"
        ess_register   GIR.TCR.ReadTempLow 	xDig    "-s$slot  -o0x48 -w16 -pro -fx -b0 -l9"
        ess_register   GIR.TCR.ReadCounter 	xDig    "-s$slot  -o0x4A -w16 -pro -fx -b0 -l9"
        ess_register   GIR.TCR.ReadSlope 	xDig    "-s$slot  -o0x4C -w16 -pro -fx -b0 -l9"
        ess_register   GIR.TCR.StartConvert 	xDig    "-s$slot  -o0x4E -w16 -prw -fx -b0 -l9"
        ess_register   GIR.TCR.ReadSlope 	xDig    "-s$slot  -o0x50 -w16 -prw -fx -b0 -l9"
        ess_register   GIR.TCR.ClearAlarm       xDig    "-s$slot  -o0x52 -w16 -pwo -fx -b5 -l2"
        ess_register   GIR.TCR.ReadConfig.Low   xDig    "-s$slot  -o0x54 -w16 -pro -fx -b5 -l1"
        ess_register   GIR.TCR.ReadConfig.High  xDig    "-s$slot  -o0x54 -w16 -pro -fx -b6 -l1"

#   XCPROM DAC Buffer settings ( -o => write address; -O => read address )

	ess_register   BufferSetup.NonVolatile.DAC0   xDig    "-s$slot  -o0x120 -O0x100 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC1   xDig    "-s$slot  -o0x122 -O0x102 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC2   xDig    "-s$slot  -o0x124 -O0x104 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC3   xDig    "-s$slot  -o0x126 -O0x106 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC4   xDig    "-s$slot  -o0x128 -O0x108 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC5   xDig    "-s$slot  -o0x12a -O0x10a -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC6   xDig    "-s$slot  -o0x12c -O0x10c -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC7   xDig    "-s$slot  -o0x12e -O0x10e -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC8   xDig    "-s$slot  -o0x130 -O0x110 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC9   xDig    "-s$slot  -o0x132 -O0x112 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC10  xDig    "-s$slot  -o0x134 -O0x114 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC11  xDig    "-s$slot  -o0x136 -O0x116 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC12  xDig    "-s$slot  -o0x138 -O0x118 -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC13  xDig    "-s$slot  -o0x13a -O0x11a -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC14  xDig    "-s$slot  -o0x13c -O0x11c -w16 -prw -fx -b0 -l0"
	ess_register   BufferSetup.NonVolatile.DAC15  xDig    "-s$slot  -o0x13e -O0x11e -w16 -prw -fx -b0 -l0"

#    GIR registers      (0x300-0x3fe)

        ess_register   GIR.EvNum.Count         xDig  "-s$slot  -o0x300 -w16 -prw -fx -b0 -l0"
        if {[first [split $registerbase #]] == "$registerbase"} then {
            ess_register   GIR.EvNum.Addr          xAdr  "-s$slot  -c0 -o0x302 -w16 -b0 -l0 -i$registerbase.GIR.EvNum"
        } else {
            ess_register   GIR.EvNum.Addr          xDig  "-s$slot  -c0 -o0x302 -w16 -prw -fx -b0 -l0"
        }
        ess_register   GIR.EvNum               xDig  "-s$slot  -o0x300 -w32 -pro -fx -b0 -l0"

        ess_register   GIR.FIFO.Test           xDig  "-s$slot  -o0x304 -w32 -prw -fx"

#    DSP Control Register
        ess_register   GIR.DCR                     xDig    "-s$slot  -o0x308 -w16 -prw -fx -b0 -l0 -i0"
        ess_register   GIR.DCR.DataXfer1.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fd -b0 -l1"
        ess_register   GIR.DCR.DataXfer2.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fd -b1 -l1"
        ess_register   GIR.DCR.DSP_Enable          xDig    "-s$slot  -o0x308 -w16 -prw -fd -b2 -l1"
        ess_register   GIR.DCR.DMA_TEST            xDig    "-s$slot  -o0x308 -w16 -prw -fd -b3 -l1"
        ess_register   GIR.DCR.Process          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l4"
        ess_register   GIR.DCR.Spectre          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l1"
        ess_register   GIR.DCR.Scaler          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b5 -l1"
        ess_register   GIR.DCR.bit6          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b6 -l1"
        ess_register   GIR.DCR.bit7          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b7 -l1"


#    GIR Readout Control Register
        ess_register   GIR.RCR                         xDig    "-s$slot  -o0x30a -w16 -prw -fx -b0 -l0 -i0"
        ess_register   GIR.RCR.ValAck.TimeOutReset     xDig    "-s$slot  -o0x30a -w16 -prw -fd -b0 -l1 -i1"
        ess_register   GIR.RCR.ReadOut.Disable         xDig    "-s$slot  -o0x30a -w16 -prw -fd -b1 -l1"
        ess_register   GIR.RCR.EvNumData.Disable       xDig    "-s$slot  -o0x30a -w16 -prw -fd -b2 -l1"
        ess_register   GIR.RCR.EvNumQbits.Enable       xDig    "-s$slot  -o0x30a -w16 -prw -fd -b3 -l1"
        ess_register   GIR.RCR.PipeLine.Enable         xDig    "-s$slot  -o0x30a -w16 -prw -fd -b4 -l1"
        ess_register   GIR.RCR.CommonDeadTime.Enable   xDig    "-s$slot  -o0x30a -w16 -prw -fd -b5 -l1"
        ess_register   GIR.RCR.ExtReadout.Enable       xDig    "-s$slot  -o0x30a -w16 -prw -fd -b6 -l1"
        ess_register   GIR.RCR.TestParil.Enable        xDig    "-s$slot  -o0x30a -w16 -prw -fd -b7 -l1"

#    GIR Readout Status Register (GIR V5)
        ess_register   GIR.ROTSR                        xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l0"
        ess_register   GIR.ROTSR.Temp.Status            xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l6"
        ess_register   GIR.ROTSR.Temp.Status.GIR      xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l2"
        ess_register   GIR.ROTSR.Temp.Status1           xDig    "-s$slot  -o0x30c -w16 -pro -fx -b2 -l2"
        ess_register   GIR.ROTSR.Temp.Status2           xDig    "-s$slot  -o0x30c -w16 -pro -fx -b4 -l2"
        ess_register   GIR.ROTSR.ValAck.TimeOut.Status  xDig    "-s$slot  -o0x30c -w16 -pro -fd -b6 -l1"
        ess_register   GIR.ROTSR.FIFO.Status            xDig    "-s$slot  -o0x30c -w16 -pro -fd -b7 -l2"

        ess_register   GIR.ValAck.TimeOut      xDAC  "-s$slot -c0 -a0 -z0 -o0x30e -w16 -prw -qn -us -d0 -r0:0s,0xffff:2048000ns -i75000ns"

#    DSP registers

	ess_register   GIR.DSP.ExtMem     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	ess_register   GIR.DSP.IntMem     bVXI    "-s$slot  -a0x400000 -o0x0 -w32 -pro -fx -l64"
	ess_register   GIR.DSP.SpectrumData     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	ess_register   GIR.DSP.Program    xGIR    "-s$slot  -a0x400010 -l0"

	ess_register   GIR.DSP.Control      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l0"

	ess_register   GIR.DSP.StartDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l1"
	ess_register   GIR.DSP.FIlterMode   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b1 -l1"
	ess_register   GIR.DSP.StopDSP      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b2 -l1"
	ess_register   GIR.DSP.DSPtotcount  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b3 -l1"
	ess_register   GIR.DSP.ResetDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b4 -l1"
	ess_register   GIR.DSP.Muxalim      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b5 -l1"
	ess_register   GIR.DSP.PZ           xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b6 -l1"
	ess_register   GIR.DSP.ResetMemExt  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b7 -l1"
	ess_register   GIR.DSP.Process      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l4"
	ess_register   GIR.DSP.Spectre      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l1"
	ess_register   GIR.DSP.Scaler       xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b9 -l1"

	ess_register   GIR.DSP.Bit10        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b10 -l1"
	ess_register   GIR.DSP.Bit11        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b11 -l1"
	ess_register   GIR.DSP.Bit12        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b12 -l1"
	ess_register   GIR.DSP.Bit13        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b13 -l1"
	ess_register   GIR.DSP.Bit14        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b14 -l1"
	ess_register   GIR.DSP.Bit15        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b15 -l1"
	ess_register   GIR.DSP.Bit16        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b16 -l1"
	ess_register   GIR.DSP.Bit17        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b17 -l1"

	ess_register   GIR.DSP.Syscon       xDig    "-s$slot  -a0x400000 -o0x0 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Wait         xDig    "-s$slot  -a0x400000 -o0x8 -w32 -prw -fd -b12 -l3 "

	ess_register   GIR.DSP.Reg0         xDig    "-s$slot  -a0x400000 -o0x98000 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Item         xDig    "-s$slot  -a0x400000 -o0x98004 -w32 -prw -fx -b0 -l0"
	ess_register   GIR.DSP.Reg2         xDig    "-s$slot  -a0x400000 -o0x98008 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Reg3         xDig    "-s$slot  -a0x400000 -o0x9800C -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Reg4         xDig    "-s$slot  -a0x400000 -o0x98010 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Reg5         xDig    "-s$slot  -a0x400000 -o0x98014 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.Reg6         xDig    "-s$slot  -a0x400000 -o0x98018 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.DeltaPZ      xDig    "-s$slot  -a0x400000 -o0x9801C -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.inmux        xDig    "-s$slot  -a0x400000 -o0x98080 -w32 -prw -fd -b0 -l0 "
	ess_register   GIR.DSP.PosBit       xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b0 -l6 "
	ess_register   GIR.DSP.NbBit        xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b6 -l6 "

#    Readout Setup Area   (0x400 - 0xffe)

}

proc ESSDetectorRegisters {slot socket} {
    global registerbase

        set c [expr $socket - 1]

#    Readout Enable Register

        ess_register   TDC.QA.ROEnable      xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b0 -l1"
        ess_register   TDC.QB.ROEnable      xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b1 -l1"
        ess_register   TDC.QC.ROEnable      xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b2 -l1"
        ess_register   TDC.QD.ROEnable      xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b3 -l1"
        ess_register   TDC.ROEnable         xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b4 -l1"
        ess_register   Pattern.ROEnable     xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b5 -l1"
        ess_register   Energy.ROEnable      xDig    "-s$slot -c$c -z0x2  -a0x400 -o0x0 -w16 -prw -fd -b6 -l1"

#    Item/Group setup
        ess_register   TDC.QA.Addr          xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0x0 -w16 -b0 -i$registerbase.TDC.QA"
        ess_register   TDC.QB.Addr          xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0x2 -w16 -b0 -i$registerbase.TDC.QB"
        ess_register   TDC.QC.Addr          xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0x4 -w16 -b0 -i$registerbase.TDC.QC"
        ess_register   TDC.QD.Addr          xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0x6 -w16 -b0 -i$registerbase.TDC.QD"
        ess_register   TDC.Addr             xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0x8 -w16 -b0 -i$registerbase.TDC"
        ess_register   Pattern.Addr         xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0xa -w16 -b0 -i$registerbase.Pattern"
        ess_register   Energy.Addr          xAdr    "-s$slot -c$c -z0x10  -a0x410 -o0xc -w16 -b0 -i$registerbase.Energy"

#    DAC setup   (0x1n00 => 0x1nfe   n=0=>3)

        ess_register   BGO.QA.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x0 -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   BGO.QB.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x2 -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   BGO.QC.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x4 -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   BGO.QD.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x6 -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"

        ess_register   CSI.QA.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x8 -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   CSI.QB.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0xa -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   CSI.QC.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0xc -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"
        ess_register   CSI.QD.Thresh        xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0xe -w16 -pwo -qK -ueV -d0 -r0:0KeV,0xff:255KeV"


        ess_register   LT.FTSample          xDAC    "-s$slot -c$c -z0x100  -a0x1000 -o0x8 -w16 -pwo -qm -uV -d0 -r0:0V,0xff:3060mV"
        ess_register   LT.ValSample         xDig    "-s$slot -c$c -z0x100  -a0x1000 -o0x12 -w16 -pwo -fx -b0 -l0"
        ess_register   LT.Watchdog          xDig    "-s$slot -c$c -z0x100  -a0x1000 -o0x14 -w16 -pwo -fx -b0 -l0"

        ess_register   BGO.PD               xDig    "-s$slot -c$c -z0x100  -a0x1000 -o0x18 -w16 -pwo -fx -b0 -l0"
        ess_register   CSI.PD               xDig    "-s$slot -c$c -z0x100  -a0x1000 -o0x1a -w16 -pwo -fx -b0 -l0"

#    Channel Control Register (0x1n20 n=0=>3)

        ess_register   CCR                  xDig    "-s$slot -c$c -z0x100  -a0x1020 -o0x0 -w16 -prw -fx -b0 -l0"
        ess_register   CCR.Enable           xDig    "-s$slot -c$c -z0x100  -a0x1020 -o0x0 -w16 -prw -fd -b0 -l1"
        ess_register   CCR.LTStartMode      xDig    "-s$slot -c$c -z0x100  -a0x1020 -o0x0 -w16 -prw -fd -b1 -l1"
        ess_register   CCR.SSEnable         xDig    "-s$slot -c$c -z0x100  -a0x1020 -o0x0 -w16 -prw -fd -b2 -l1"
        ess_register   CCR.SSDAC            xDig    "-s$slot -c$c -z0x100  -a0x1020 -o0x0 -w16 -prw -fd -b3 -l1"

#    Time Alignment Registers   (0x1n22 => 0x1n3e   n=0=>3)

        ess_register   BGO.QA.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x0 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   BGO.QB.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x2 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   BGO.QC.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x4 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   BGO.QD.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x6 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"

        ess_register   CSI.QA.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x8 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   CSI.QB.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0xa -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   CSI.QC.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0xc -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   CSI.QD.AlignDelay    xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0xe -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"

        ess_register   Ge.QA.AlignDelay     xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x10 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   Ge.QB.AlignDelay     xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x12 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   Ge.QC.AlignDelay     xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x14 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"
        ess_register   Ge.QD.AlignDelay     xDAC    "-s$slot -c$c -z0x100  -a0x1022 -o0x16 -w16 -pwo -qn -us -d0 -r0:0ns,0x3f:630ns"

#    TDC Control Registers   (0x1n40 => 0x1n48   n=0=>3)

        ess_register   TDC.QA.StopSelect    xDig    "-s$slot -c$c -z0x100  -a0x1040 -o0x0 -w16 -pwo -fd -b0 -l0"
        ess_register   TDC.QB.StopSelect    xDig    "-s$slot -c$c -z0x100  -a0x1040 -o0x2 -w16 -pwo -fd -b0 -l0"
        ess_register   TDC.QC.StopSelect    xDig    "-s$slot -c$c -z0x100  -a0x1040 -o0x4 -w16 -pwo -fd -b0 -l0"
        ess_register   TDC.QD.StopSelect    xDig    "-s$slot -c$c -z0x100  -a0x1040 -o0x6 -w16 -pwo -fd -b0 -l0"
        ess_register   TDC.Select           xDig    "-s$slot -c$c -z0x100  -a0x1040 -o0x8 -w16 -pwo -fd -b0 -l0"

#    Others

        ess_register   VetoDelay            xDAC    "-s$slot -c$c -z0x100  -a0x104a -o0x0 -w16 -pwo -qn -us -d0 -r0:0ns,0xf:150ns"
        ess_register   VetoWidth            xDAC    "-s$slot -c$c -z0x100  -a0x104c -o0x0 -w16 -pwo -qn -us -d0 -r0:0ns,0xff:2550ns"
        ess_register   PatternWidth         xDAC    "-s$slot -c$c -z0x100  -a0x104e -o0x0 -w16 -pwo -qn -us -d0 -r0:0ns,0xff:2550ns"

#    DAC Buffer Settings (volatile mode)   (0x1n50 => 0x1n52   n=0=>3)

        ess_register   DACBufferVolatile1   xDig    "-s$slot -c$c -z0x100 -a0x1050 -o0x00 -w16 -pwo -fx -b0 -l0"
        ess_register   DACBufferVolatile2   xDig    "-s$slot -c$c -z0x100 -a0x1050 -o0x02 -w16 -pwo -fx -b0 -l0"
}


proc ESS_DAQ-setup   {args}   {
   set module [first $args]
#    actions to be determined
}

proc ESS_DAQ-reset   {args}   {
   set module [first $args]
#    flush FIFOs
   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0
#    reset and enable GIR
   write-vxi-register $module.GIR.FIFO.Test 0
   read-vxi-register $module.GIR.FIFO.Test
}

proc ESS_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}


proc ESS_DAQ-go   {args}   {
   set module [first $args]
#    zero event numbers
   write-vxi-register $module.GIR.EvNum.Count 0
}
