#    part of the Diagnostic task for testing GIR DSP functions
#    this is muxalim.tcl

#    the global variable dsp is dependent on the GIR version fitted 
#    it is set when the slot is selected
global inmux wait posbit nbbit moduleindex card

set inmux 10
set wait 0
set posbit 0
set nbbit 12
set modeauto 0


  :frame [self frame-name].muxalim :label "Power Supply Status" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F


    :panel MUXALIMP3 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :text     MODULE    :label "Current MODULE:" :deaf T :w 4 :bold T :value $moduleindex
     :text     CARD    :label "Current CARD:" :deaf T :w 8 :bold T :value $card
     :next-row T
     :number MUXALIMINMUX  :w 2 :label "Input Mux"  :min 0 :max 15 :value $inmux :valuex 14c
     :number MUXALIMWAIT  :w 2 :label "Nb Waitstates" :min 0 :max 6 :value $wait :valuex 12c
     :next-row T
     :number MUXALIMPOSBIT  :w 2 :label "Pos Bits"  :min 0 :max 6 :value $posbit :valuex 14c
     :number MUXALIMNBBIT  :w 2 :label "Nb Bits"  :min 10 :max 16 :value $nbbit :valuex 12c
     :next-row T
     :slider MUXDAC     :label "Offset (mV):" :min -496 :max 496 :valuex 14c :value 0
     :next-row T
     :slider MUXPOTAR     :label "Rgain (Ohm):" :min 50 :max 10011  :valuex 14c :value 10011
     :next-row T
     :button MUXALIMSCAN  :label SCANN :w 12
     :checkbox     AUTO    :label "Auto:" :command auto
     :button MUXALIMSPECTRE  :label "SPECTRE" :w 12 
     :next-row T
     :button MUXALIMSTOP  :label STOP :w 12
     :button MUXALIMRESET  :label RESET :w 12
     :next-row T
	:galley MUXALIMRESULTS  :rows 8 :cols 30 :deaf T

     :button MUXALIMREFRESH  :label "Update"


   :show T
write-vxi-register $CurrentVXIModule.GIR.DSP.PosBit $posbit
write-vxi-register $CurrentVXIModule.GIR.DSP.Wait $wait
write-vxi-register $CurrentVXIModule.GIR.DSP.NbBit $nbbit
write-vxi-register $CurrentVXIModule.GIR.DSP.inmux 0x10A00000


#####################
proc auto {p v} {
global $p modeauto
 set $p $v
set modeauto $v
log "modeauto = $modeauto"
}

 ###################################
proc click-muxdac {p} {
   global $p CurrentVXIModule

set data1 [expr abs(2.048*(($p/0.5)+1000))]
set val [expr [truncate $data1]]
write-vxi-register $CurrentVXIModule.DSP.DAC.Adj $val
}

 ###################################
proc click-muxpotar {p} {
   global $p CurrentVXIModule
set data1 [expr (($p-50)/39.45)+0.5]
set val [expr [truncate $data1]]

log "data1=$data1, val=$val"
write-vxi-register $CurrentVXIModule.DSP.POT.Adj $val
}
 ###################################
proc click-muxalimspectre {args} {
   global CurrentVXIModule modeauto inmux v

write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0

#reset
   write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
	after 500
write-vxi-register $CurrentVXIModule.GIR.DSP.inmux $inmux

#start Spectre
	write-vxi-register $CurrentVXIModule.GIR.DSP.Bit10 1
if {$modeauto == 1} then {


	for {set v 0} {$v < 7} {incr v} {
				log "v= $v"
				click-muxaliminmux $v
				after 1500
					}
					
			}
				after 1500

	write-vxi-register $CurrentVXIModule.GIR.DSP.Bit10 0

				
}

 ###################################
proc click-muxalimposbit {v} {
   global  CurrentVXIModule posbit

write-vxi-register $CurrentVXIModule.GIR.DSP.PosBit $v
set posbit $v
}
 ###################################
proc click-muxalimwait {v} {
   global CurrentVXIModule wait
write-vxi-register $CurrentVXIModule.GIR.DSP.Wait $v
set wait $v
}


 ###################################
proc click-muxalimnbbit {v} {
   global  CurrentVXIModule nbbit

write-vxi-register $CurrentVXIModule.GIR.DSP.NbBit $v
set nbbit $v
}

 ###################################
proc click-muxaliminmux {v} {
   global  CurrentVXIModule inmux
set data2 0x10000000
set data [expr ($v*0x100000)+$data2]
write-vxi-register $CurrentVXIModule.GIR.DSP.inmux $data

set inmux $data
}
 ###################################
proc click-muxalimscan {args} {
   global CurrentVXIModule inmux

write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0


#reset
	write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
	after 500
write-vxi-register $CurrentVXIModule.GIR.DSP.inmux $inmux

#start Scann
	write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 1

	after 5000
#stop Scann
	write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0
	ReadAlim	

}

 ###################################
proc click-muxalimstop {args} {
   global CurrentVXIModule

#stop Spectre
	write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0
}

 ###################################
proc click-muxalimreset {args} {
   global CurrentVXIModule

#reset
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
}
###################################
proc click-muxalimrefresh {args} {
   global moduleindex card
  :modify MODULE :value $moduleindex
  :modify CARD :value $card

  ReadAlim
}

###################################
proc click-muxaliminfo args {
    global TclBase
   midas-show-file  "$TclBase/info/explmuxalim"
}


###################################
proc click-muxalimfinish args {
   global CurrentVXIModule
	write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
    click-quit [self frame-name].muxalim
}


###################################
proc ReadAlim {} {
   global CurrentVXIModule card
    :modify MUXALIMRESULTS  :append F

switch $card {
        ClusterBGO -
	ESS {array set divtension {0 410.5 1 104.8 2 101.0 3 35.8 4 36.0 5 16.3 6 16.5} }
	HRGe8x {array set divtension {0 842.0 1 91.6 2 85.8 3 29.4 4 29.7 5 13.4 6 13.8} }
		}

   array set nomalim    {0 -2V 1 +5V  2 -5.2V  3 +12V 4 -12V 5 +24V 6 -24V}

        set basealim [expr (0x26215*4)]
        set basedelta [expr (0x2621c*4)]

	set length 7

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basealim -l $length"
        set data_alim [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
        set i 0
foreach wordalim $data_alim {

        set data_volt [expr ($wordalim)/($divtension($i))]
        set alim($i) $data_volt
        incr i
				}

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basedelta -l $length"
        set data_alim [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
        set i 0
foreach wordalim $data_alim {
	if {$wordalim != 0} then {set delta($i) "out of range"} else {set delta($i) "OK"}
        incr i
				}


for {set i 0} {$i < 7} {incr i} {
	:modify MUXALIMRESULTS :strings "[format "%5s  :  %3.2fV   :  %s" $nomalim($i) $alim($i) $delta($i)]\n"
				}

}

