#    part of the Diagnostic task for testing GIR DSP functions
#    this is muxalim.tcl

#    the global variable dsp is dependent on the GIR version fitted 
#    it is set when the slot is selected



  :frame [self frame-name].muxalim :label "Power Supply Status" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel MUXALIMP1 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 2
     :message TITRE :label "   alim :    value : "
     :galley MUXALIMRESULTS  :rows 8 :cols 30 :deaf T

    :panel MUXALIMP2 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :button MUXALIMREFRESH  :label "Display"
     :button MUXALIMINFO  :label Info
     :button MUXALIMFINISH  :label Quit 

   :show T

 

###################################
proc click-muxaliminfo args {
    global TclBase
   midas-show-file  "$TclBase/info/explmuxalim"
}


###################################
proc click-muxalimfinish args {
   global CurrentVXIModule
    write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
    click-quit [self frame-name].muxalim
}



###################################
proc click-muxalimrefresh {args} {
   global girversion dsp CurrentVXIModule

    write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
    write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 1


taskDelay 10
    write-vxi-register $CurrentVXIModule.GIR.DSP.Muxalim 0

ReadAlim
}

###################################
proc ReadAlim {} {
   global girversion sram CurrentVXIModule

   array set divtension {0 1.0 1 2.47 2 2.54 3 5.87 4 5.87 5 11.7 6 11.7}
   array set nomalim    {0 -2V 1 +5V  2 -5.2V  3 +12V 4 -12V 5 +24V 6 -24V}

   switch $girversion {
      4 {
        set basealim [expr (0x26b3a*4)]
        set basedelta [expr (0x26b41*4)]
	set regmux  $CurrentVXIModule.GIR.DSP.IntMem
        }
      3 {
	write-vxi-register $CurrentVXIModule.GIR.DSP.Mirror 1
        set basealim [expr (0x7fef2 * 4) ]
        set basedelta [expr (0x7fef9 * 4) ]
	set regmux  $CurrentVXIModule.GIR.DSP.ExtMem

        }
    }
	set length 7

	modify-vxi-register $regmux "-o $basealim -l $length"
        set data_alim [read-vxi-register $regmux]
        set i 0
foreach wordalim $data_alim {
        set data_volt [expr (5 * ($wordalim - 0.5) - 640)/256]
        set alim($i) [expr $data_volt * $divtension($i)]
        incr i
				}

	modify-vxi-register $regmux "-o $basedelta -l $length"
        set data_delta [read-vxi-register $regmux]
        set i 0
foreach wordelta $data_delta {
	if {$wordelta != 0} then {set delta($i) "out of range"} else {set delta($i) "OK"}
        incr i
				}

for {set i 0} {$i < 7} {incr i} {
	:modify MUXALIMRESULTS :strings "[format "%5s  :  %8.2fV   :  %s" $nomalim($i) $alim($i) $delta($i)]\n"
				}

}

