#    part of the Diagnostic task for testing GIR DSP functions
#    this is spectre.tcl

#    the global variable dsp is dependent on the GIR version fitted
#   it is set when the slot is selected
#    also the variable sar is used which should be set when the board type is selected
# this version is adapted to HRGe8x ESS TGIR and ECC card for EXOGAM experiment

  set maxadcchan 63
  set adcchannel 0
  set modesingles 0
set adcdatabits 14
global adcdatabits moduleindex card

  :frame [self frame-name].exospectre :label "Spectra Control" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F 
      


    :panel SPECTREP1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 5
      :text     MODULE    :label "Current MODULE:" :deaf T :valuex 20c :w 4 :bold T :value $moduleindex
      :text     CARD    :label "Current Card:" :deaf T :valuex 15c :w 8 :bold T :value $card
     :next-row T
     :checkbox     ONLYSINGLES    :label "Only Singles:" :command setonlysingles
     :next-row T
     :number SPECTREADCBITS  :w 2 :label "nb bits ADC" \
			:min 10 :max 19 :value $adcdatabits
     :next-row T
     :galley SPECTRERESULTS :rows 8 :cols 40 :deaf T


   :panel SPECTREP2 :layout T :padx 5 :pady 10
     :layout H; :col-gap 10; :row-gap 5
     :row-gap 0

     :message SPECTREMESS  :label "ADC channel: Spectrum: "
     :next-row T
     :number SPECTREADCCHAN  :w 2 :label "" \
			:min 0 :max $maxadcchan :value $adcchannel

     :button SPECTRESHOW  :label "Show"
     :button SPECTREZERO  :label "Zero"
     :button SPECTRECREATE  :label "Create"



    :panel SPECTREP3 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 10

     :row-gap 0
     :message SPECTRETPEAKP2  :label "ADC channel:      total: countmax: canalmax "
     :galley SPECTRETPEAKINFO :rows 10 :cols 45 :deaf T
     :row-gap 5


    :panel SPECTREPA1 :layout T :padx 10 :pady 5
     :layout H; :col-gap 5; :row-gap 5
     :button SPECTREUPDATE :label Update
     :button SPECTRERESET  :label "Reset" :w 4
     :button INFO	:label "Info"   :w 4 
     :button SPECTREQUIT :label "Quit"   :w 4

position-frame 200 0 [self frame-name].exospectre


 
		

#####################
proc setonlysingles {p v} {
global $p modesingles adcdatabits
 set $p $v
set adcdatabits [expr (14-$v) ]
set modesingles $v
}
#####################
proc click-info {args} {
   global TclBase
   midas-show-file  "$TclBase/info/explspectre"
			}

#####################
proc click-spectrequit {args} {
#   global girspectreexists

#  set girspectreexists 0

   click-quit [self frame-name].exospectre
}



#####################
proc click-spectrereset {args} {
    global CurrentVXIModule

    if {![midas-confirmation "Are you sure you wish to Reset?"]} then {return}
    :modify SPECTRETPEAKINFO  :append F
    write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0

    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
    refresh-results

}
#####################
proc click-spectreupdate {args} {
	global CurrentVXIModule card moduleindex

        :modify MODULE :value $moduleindex
        :modify CARD :value $card

#   set daqstate [read-vxi-register $CurrentVXIModule.GIR.DSP.AcqDSP]
#   set dspmode [read-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer]


   set daqstate [read-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP]
   set dspmode [read-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer2.Enable]

#   write-vxi-register $CurrentVXIModule.GIR.DSP.AcqDSP 0
#   write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer 0

    write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 0
    write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer2.Enable 0

    write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0
   write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode 0

    write-vxi-register $CurrentVXIModule.GIR.DSP.DSPtotcount 1
	refresh-results
 	do_totpeak$card


   write-vxi-register $CurrentVXIModule.GIR.DSP.FilterMode $dspmode
   write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP $daqstate
write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer2.Enable $dspmode
write-vxi-register $CurrentVXIModule.GIR.DCR.DataXfer1.Enable 1

}

#####################
proc refresh-results {args} {
   global CurrentVXIModule
    
ReadEvent
}


#####################
proc click-spectreadcchan {v} {
    global adcchannel
    set adcchannel $v
}

#####################
proc click-spectreadcbits {v} {
    global adcdatabits
    set adcdatabits $v
}

#####################
proc click-spectreshow {args} {
   global adcchannel server CurrentVXIModule slot

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   inform sd show /$server/$f
   set-footer [self frame-name].exospectre "Displaying Spectrum /$server/$f"
}

#####################
proc click-spectrezero {args} {
   global adcchannel server CurrentVXIModule slot card

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   zero-spectrum $f
   set-footer [self frame-name].exospectre "Zeroing Spectrum /$server/$f"
    write-vxi-register $CurrentVXIModule.GIR.DSP.DSPtotcount 1
	    do_totpeak$card

}

#####################
proc click-spectrecreate {args} {
   global adcchannel server CurrentVXIModule slot

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   set-footer [self frame-name].exospectre "Created Spectrum /$server/$f"
}
	

#    procedures ReadEvent and ReadTotpeak  moved from  gesdsp.c


#####################
proc ReadEvent {} {
   global CurrentVXIModule

   array set nomevent {0 "Item0" 1 "DSP Events Counter" 2  "Last event data number" 3 "Item Error" \
       4  "Data number Error" 5 "GIR Event Counter"}
 
   :modify SPECTRERESULTS :append F
	set length 5
set i 0


      	set baseevent [expr (0x26001*4)]
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $baseevent -l $length"	
      	set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

       foreach word $DataRAM {
:modify SPECTRERESULTS :strings "[format "%24s   :   0x%x" $nomevent($i) $word]\n"
incr i}

set compgir [read-vxi-register $CurrentVXIModule.GIR.EvNum.Count]
:modify SPECTRERESULTS :strings "[format "%24s   :   0x%x" $nomevent(5) $compgir]\n"

}

################################ ESS temporary DOTOTAL PEAK ##################################3

proc do_totpeakESS {} {
  global CurrentVXIModule modesingles adcdatabits
   :modify SPECTRETPEAKINFO :append F

   array set crystal {0 A 1 B 2 C 3 D}

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe
	set length 4

set j 0

   for {set i 0} {$i<4} {incr i} {

	
	set k [expr $i*32]
	set adc [expr ($i*4)]


      	set basetpeak [expr (0x26140*4) +$k]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set seg 0

foreach wordcount $datacount {
        set totcount($seg)  $wordcount

if {$totcount($seg) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s.ADC%d : %d : 0x%x"  $j $crystal($i) $seg  $totcount($seg) $totcount($seg)]\n"
				}
incr seg
incr j						}



      	set basetpeak [expr (0x26144*4) +$k]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set seg 0
foreach wordcount $datacount {
        set totcount($seg)  $wordcount

if {$totcount($seg) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s.TDC%s : %d : 0x%x" $j $crystal($i) $seg  $totcount($seg) $totcount($seg)]\n"
				}
incr seg
incr j						}

		     			 }
}
#####################



################################ TGIR DOTOTAL PEAK ##################################3



proc do_totpeakTGIR {} {
  global CurrentVXIModule modesingles adcdatabits
   :modify SPECTRETPEAKINFO :append F

   array set crystal {0 A 1 B 2 C 3 D}

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe
	set length 4

set j 0

   for {set i 0} {$i<4} {incr i} {

	
	set k [expr $i*32]
	set adc [expr ($i*4)]


      	set basetpeak [expr (0x26140*4) +$k]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set seg 0

foreach wordcount $datacount {
        set totcount($seg)  $wordcount

if {$totcount($seg) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s.ADC%d : %d : 0x%x"  $j $crystal($i) $seg  $totcount($seg) $totcount($seg)]\n"
				}
incr seg
incr j						}



      	set basetpeak [expr (0x26144*4) +$k]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set seg 0
foreach wordcount $datacount {
        set totcount($seg)  $wordcount

if {$totcount($seg) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s.TDC%s : %d : 0x%x" $j $crystal($i) $seg  $totcount($seg) $totcount($seg)]\n"
				}
incr seg
incr j						}

		     			 }
}
################################ HRGe8x DOTOTAL PEAK ##################################3

proc do_totpeakHRGe8x {} {
  global CurrentVXIModule modesingles adcdatabits
   :modify SPECTRETPEAKINFO :append F
switch $modesingles {
0 {

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#mode correles (+ singles)

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe


   for {set i 0} {$i<8} {incr i} {
	set adc0 [expr ($i*3)]
	set adc [expr ($i*3)]
	set length 3
      	set basetpeak [expr (0x26140*4) + ($adc*4)]
      	set picmax [expr (0x26160*4) + ($adc*4)]
      	set posmax [expr (0x26180*4) + ($adc*4)]


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

foreach wordcount $datacount {
        set totcount($adc)  $wordcount
	set typevoie($adc) [expr ($adc-$adc0)]

	switch $typevoie($adc) {
			0 { set typch($adc) "6Mev"}
			1 { set typch($adc) "20Mev"}
			2 { set typch($adc) "Tac"}
			}
incr adc
				}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpic $datapic {
	set listpic($adc) $worpic
incr adc
			}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpos $datapos {
	set listpos($adc) $worpos
incr adc
			}
set maxadc $adc

for {set adc $adc0} {$adc<$maxadc} {incr adc} {
if {$totcount($adc) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s%s : %d : 0x%x" $adc $typch($adc) $i $totcount($adc) $totcount($adc)]\n"
				}
						}
			

     			 }

	set length 8

      	set basetpeak [expr (0x26158*4) ]
      	set picmax [expr (0x26178*4) ]
      	set posmax [expr (0x26198*4) ]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach wordcount $datacount {set totcount($i)  $wordcount
incr i}


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach worpic $datapic {set listpic($i) $worpic
incr i}

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach worpos $datapos {set listpos($i) $worpos
incr i}

set adc 24
for {set i 0} {$i<8} {incr i} {
if {$totcount($i) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Single%d : %d : 0x%x" $adc  $i $totcount($i) $totcount($i)]\n"

				}
incr adc
			

     			 }
}

1 {
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#mode  only singles

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe


   for {set i 0} {$i<8} {incr i} {
	set adc0 [expr ($i*8)]
	set adc [expr ($i*8)]
	set length 8
      	set basetpeak [expr (0x26140*4) + ($adc*4)]
      	set picmax [expr (0x26180*4) + ($adc*4)]
      	set posmax [expr (0x261C0*4) + ($adc*4)]


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

foreach wordcount $datacount {
        set totcount($adc)  $wordcount
	incr adc
				}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpic $datapic {
	set listpic($adc) $worpic
incr adc
			}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpos $datapos {
	set listpos($adc) $worpos
incr adc
			}
set maxadc $adc

for {set adc $adc0} {$adc<$maxadc} {incr adc} {
if {$totcount($adc) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Single%d.Tac%d : %d : %d : %d" $adc  $i $adc $totcount($adc) $listpic($adc) $listpos($adc)]\n"
				}
}
			
}							
#end for {set i 0}
}
#end mode 1
}
#end proc
}



################################ ECC DOTOTAL PEAK ##################################3



proc do_totpeakECC {} {
  global CurrentVXIModule modesingles adcdatabits
   :modify SPECTRETPEAKINFO :append F
switch $modesingles {
0 {

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#mode correles (+ singles)

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe


   for {set i 0} {$i<8} {incr i} {
	set adc0 [expr ($i*3)]
	set adc [expr ($i*3)]
	set length 3
      	set basetpeak [expr (0x26140*4) + ($adc*4)]
      	set picmax [expr (0x26160*4) + ($adc*4)]
      	set posmax [expr (0x26180*4) + ($adc*4)]


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

foreach wordcount $datacount {
        set totcount($adc)  $wordcount
	set typevoie($adc) [expr ($adc-$adc0)]

	switch $typevoie($adc) {
			0 { set typch($adc) "6Mev"}
			1 { set typch($adc) "20Mev"}
			2 { set typch($adc) "Tac"}
			}
incr adc
				}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpic $datapic {
	set listpic($adc) $worpic
incr adc
			}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpos $datapos {
	set listpos($adc) $worpos
incr adc
			}
set maxadc $adc

for {set adc $adc0} {$adc<$maxadc} {incr adc} {
if {$totcount($adc) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s%s : %d : 0x%x" $adc $typch($adc) $i $totcount($adc) $totcount($adc)]\n"
				}
						}
			

     			 }

	set length 8

      	set basetpeak [expr (0x26158*4) ]
      	set picmax [expr (0x26178*4) ]
      	set posmax [expr (0x26198*4) ]

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach wordcount $datacount {set totcount($i)  $wordcount
incr i}


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach worpic $datapic {set listpic($i) $worpic
incr i}

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
set i 0
foreach worpos $datapos {set listpos($i) $worpos
incr i}

set adc 24
for {set i 0} {$i<8} {incr i} {
if {$totcount($i) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Single%d : %d : 0x%x" $adc  $i $totcount($i) $totcount($i)]\n"

				}
incr adc
			

     			 }
}

1 {
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#mode  only singles

# i est le nb de voie d'entree
# adc=length est le nb d'item par voie
# i*adc est le nb de cases ds la memoire externe


   for {set i 0} {$i<8} {incr i} {
	set adc0 [expr ($i*8)]
	set adc [expr ($i*8)]
	set length 8
      	set basetpeak [expr (0x26140*4) + ($adc*4)]
      	set picmax [expr (0x26180*4) + ($adc*4)]
      	set posmax [expr (0x261C0*4) + ($adc*4)]


	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
        set datacount [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

foreach wordcount $datacount {
        set totcount($adc)  $wordcount
	incr adc
				}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $picmax -l $length"
        set datapic [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpic $datapic {
	set listpic($adc) $worpic
incr adc
			}

set adc $adc0
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $posmax -l $length"
        set datapos [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
foreach worpos $datapos {
	set listpos($adc) $worpos
incr adc
			}
set maxadc $adc

for {set adc $adc0} {$adc<$maxadc} {incr adc} {
if {$totcount($adc) != 0} then {
	:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Single%d.Tac%d : %d : %d : %d" $adc  $i $adc $totcount($adc) $listpic($adc) $listpos($adc)]\n"
				}
}
			
}							
#end for {set i 0}
}
#end mode 1
}
#end proc
}







#####################
proc get-spectrum-list {slot} {
   global server maxadcchan
   set splist {}
   for {set i 0} {$i<=$maxadcchan} {incr i} {
      lappend splist GIR$slot.c$i
   }
   return $splist
}

#####################
proc execute-spectrum {n action} {
  global server adcdatabits
  global debug

#insert-debug "$action $n"

#insert-debug "$server"
  switch $action {
     maybe-create {
        if {$debug} then {insert-debug "maybe create spectrum, checking :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' ?spec)"} m]



# Check for "Pathname Invalid" and create if it doesn't exist
        if {$z!=0 && $m==0x30004} then {
           set range [expr int (pow(2, $adcdatabits))]
           if {$debug} then {insert-debug "maybe create spectrum, creating :range $range :name '$n' "}
           set z [catch {eg "(spectrum :path '/$server' :range $range :name '$n' !new)" } m]
        }
     }
     create {
        set range [expr int (pow(2, $adcdatabits))]
        if {$debug} then {insert-debug "create spectrum :range $range :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :range $range :name '$n' !new)" } m]
     }
     delete {
        if {$debug} then {insert-debug "delete spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !delete)"} m]
# Allow "Pathname Invalid" so that further spectra can be deleted
        if {$z!=0 && $m==0x30004} then {set z 0}
     }
     clear {
        if {$debug} then {insert-debug "clear spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !zero)"} m]
     }
  }
  if {$z!=0} then {
    display-eg-error-report self $m "Attempting to " $action "spectrum" $n
    clear-footer
    error $m
  }
}

proc maybe-create-spectrum n {execute-spectrum $n maybe-create}

proc create-spectrum n {execute-spectrum $n create}

proc delete-spectrum n {execute-spectrum $n delete}

proc zero-spectrum n {execute-spectrum $n clear}

#####################
proc create-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "creating /$server/$spectrum..."
      create-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully created"
}

#####################
proc delete-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "deleting /$server/$spectrum..."
      delete-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully deleted"
}

#####################
proc zero-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "zeroing /$server/$spectrum..."
      zero-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully zeroed"
}

# at a later stage this could be more intelligent
# it could check spectrum existence and only create if necessary
# maybe zeroing otherwise
#

#####################
proc setup-spectrum n {
  delete-spectrum $n
  create-spectrum $n
}

#####################
proc setup-spectra {} {
  delete-spectra
  create-spectra
}
