#    hist task code overlay for detector type "demon"


set lowchannel  0
set highchannel 247
set maxchannel  247

set demonnames   {SYREP Entire Slow Time}

set demon 0


proc make-overlaypanel {} {
   global demonnames

    :layout V; :row-gap 10; :col-gap 20

      :message DET-M1   :label "Demon overlay applied"

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:" :w 5 :valuex 15c

      :choice DET-DEMON   :label "Items"   :valuex 15c  :exclusive F :strings $demonnames  :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-DEMON     {click-adc $v demon}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global demon

   if {[llength $spectrumlist] > 0} then {
       :modify DET-DEMON   :value 0
   } else {
       :modify DET-DEMON   :value $demon
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global demonnames demon
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}
# append  spectrum names
        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $demonnames  [bits-in $demon]]  {lappend list Demon$i.$adc}
        }
        return $list
}

proc range-of n {

    set fields [split $n "."]

    switch -glob [second $fields]  {
            SYREP      {return 4096}
            Entire     {return 4096}
            Slow       {return 4096}
            Time       {return 4096}
            default    {return 4096}
    }

}
