#    hist task code overlay for detector type "nwall"  (Euroball Neutron Wall)

set overlaytitle "Nwall (Neutron Wall) overlay applied"

set lowchannel  0
set highchannel 49
set maxchannel  49

set Histname Nwall

set adcnames   {tof zco qvc}


#    the following code should be generic for all detectors interfaced via the FVI module

proc make-overlaypanel {} {
   global adcnames overlaytitle

    :layout V; :row-gap 10; :col-gap 20

      :message DET-M1   :label "$overlaytitle"

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:" :w 5 :valuex 15c

      :choice DET-ADCS   :label "Items"   :valuex 15c  :exclusive F :strings $adcnames  :value 0
}

set adcs 0

#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-ADCS     {click-adc $v adcs}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global adcs

   if {[llength $spectrumlist] > 0} then {
       :modify DET-ADCS   :value 0
   } else {
       :modify DET-ADCS   :value $adcs
   }
}

proc get-spectrum-list {} {
        global spectrumlist
        global adcnames adcs Histname
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}
# append  spectrum names
        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $adcnames  [bits-in $adcs]]  {lappend list $Histname$i.$adc}
        }
        return $list
}

proc range-of n {return 4096}
