#    hist task code overlay for detector type "roco"


set lowchannel 0
set highchannel 255
set maxchannel 255

set roconames  {EndSub}

set roco 0


proc make-overlaypanel {} {
   global roconames qnames

      :layout V; :row-gap 10; :col-gap 0

      :message DET-M1  :label "ROCO detector overlay applied"

      :number DET-LOW  :label "Low channel:"   :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:"  :w 5 :valuex 15c

      :choice DET-ROCO  :label "Items"      :valuex  15c :exclusive F :strings $roconames :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-ROCO           {click-adc $v roco}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global roco

   if {[llength $spectrumlist] > 0} then {
       :modify DET-ROCO  :value 0
   } else {
       :modify DET-ROCO  :value $roco
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global roconames roco
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}

        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
# append roco spectrum names
           foreach adc [list-take $roconames [bits-in $roco]] {lappend list ROCO$i.$adc}
        }
        return $list
}

proc range-of n {return 0x10000}
