# resource manager frame
#    23 Mar 1996 - conversion to TK   VP

set debug 0
set started 0

set frame RM
set frametitle "Resource Manager Control"
set icontitle RM


for {set i 1} {$i <= 3} {incr i} {lappend defaultchanlist [expr 0+$i]}

set cardtype RM
set chantype ""

set chanlist {???}
set chanindex 0

set rname(MODELCODE)   VXI.ModelCode
set rname(SERIALNUM)   VXI.SerialNum 
set rname(MODLEVEL)    VXI.ModLevel
set rname(MANID)       VXI.ManID
set rname(RENO)        RENO
set rname(MEMX)        MemEch
set rname(TERM)        NoIPTerm
set rname(VXI-ENABLE)  VXI.Enable
set rname(VXI-GO)      VXI.Go
set rname(VXI-INHIBIT) VXI.Inhibit
set rname(ADC)         ADC
set rname(BUSY)        ADC.Converted
set rname(TTLTRG)      TTLTRG
set rname(ECLTRG)      ECLTRG
set rname(VME-RESET)   VME.Reset
set rname(VME-MASTER)  VME.master
set rname(VME-FORCE)   VME.DWB

for {set sid [array startsearch rname]} {[array anymore rname $sid]} { } {
	set element [array nextelement rname $sid]
	set wname($rname($element)) $element
	set r2v($element) scan-int
}

set r2v(MODELCODE) quote-text
set r2v(SERIALNUM) quote-text
set r2v(MODLEVEL)  quote-text
set r2v(MANID)     quote-text

loadsource common.vxi

proc click-redisplay {} {

	clear-footer
        redisplay "*"
}
  
proc click-on {w v} {
	global rname
	clear-footer
	set register $rname($w)
	write-vxi-reg $register $v
	click-redisplay
}


proc click-vme-force {v} {
	if {$v} then {
	    write-vxi-reg VME.Config 0x8f
	} else {
	    init-vxi-reg VME.Config
	}
	click-redisplay
}

proc click arg {
	global debug chanindex chanlist
	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$c==":quit"} then {click-quit $f; return}
	switch $w  {
		VME-FORCE    {click-vme-force $v}
                LA-START     {inform rmlactl start}
		CHANNEL      {click-channel $v}
		REDISPLAY    {click-redisplay}
                ENGINEERING  {click-$v}
		default      {click-on $w $v}
	}
}

proc make-frame1 {} {
  global env chanlist chanindex

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

  :panel PANEL :layout T :padx 10 :pady 10
    :layout H; :col-gap 10; :row-gap 10

     :choice-stack CHANNEL :label "RM:"  :valuex 12c \
         :strings [quote-list $chanlist] :value $chanindex
     :text MODELCODE       :label "Model Code:"    :w 6 :read-only T :valuex 14c
   :next-row T
      :checkbox RENO :label RENO: :valuex 12c
      :text SERIALNUM       :label "Serial Number:" :w 6 :read-only T :valuex 22c
   :next-row T
      :checkbox MEMX :label "Mem Ech:" :valuex 12c
      :text MODLEVEL :label "Modification Level:"   :w 6 :read-only T :valuex 22c
   :next-row T
      :checkbox TERM :label "No IP Terms:" :valuex 12c :deaf T
      :text MANID  :label "Manufacturer ID:" :w 6 :read-only T :valuex 22c
   :next-row T
      :checkbox VME-MASTER :label "VME Master:" :valuex 12c :deaf T
      :choice VME-FORCE :strings [list Force] :exclusive F
   :next-row T
      :choice VXI-ENABLE :label VXI: :strings [list Disable Enable] :valuex 12c
      :choice VXI-GO :strings [list Stop Go]
      :choice VXI-INHIBIT :strings [list Inhibit] :exclusive F
   :next-row T
      :text ADC-TEXT :label ADC: :w 8 :valuex 12c :read-only T
      :gauge ADC :label "" :min -5000 :max 5000 :ticks 11
      :choice BUSY :strings [list Busy] :exclusive F :deaf T
   :next-row T
      :hskip 50
      :choice ECLTRG  :label ECLTRG: :exclusive F :valuex 10c :deaf T :layout V :w 16 \
		:strings [list "Validation 1" "Synch Trig" "Inhibit Request" "Digital Insp 1" \
		          "Digital Insp 2" "Validation 2"]
      :choice TTLTRG  :label TTLTRG: :exclusive F :valuex 10c :deaf T :layout V :w 16 \
		:strings [list Coding Readout "Mem Ech" Clear  \
		          "VXI Go" "Reject Event" "Validation 3" "Inhibit Action"]
   :next-row T
     :col-gap 0
      :button REDISPLAY  :label "Redisplay"
#      :button REBOOT    :label "Reboot..."  :command click-reboot
      :button LA-START  :label "Logic Analyser..."
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button HELP      :command click-help

   :show T
}


proc make-electronics {} {
  global env electronicsvisible

  :frame [self frame-name].electronics :label "RM electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :checkbox MODE      :label "Test Mode:"                            :valuex 20c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 20c
    :next-row T
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 20c
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c
    
  :show T
 set electronicsvisible 1
}



proc click-reboot {} {

   set i [tk_dialog [self frame-name].rebootdialog "VXI Crate Reboot"  \
        "This will destroy all unsaved setups in the Crate" \
	"warning" 1 "Cancel" "Proceed"]
   if {$i} then {
     set-footer "Rebooting the Crate..."
     write-vxi-reg VME.Reset 1
     set-footer "Crate rebooted [date]..."
   }
}


