

#   tgir.defn.tcl     TGIR VXI card


proc {AddTGIRModule}  {module slot}  {
   global registerbase cardtype

   set registerbase $cardtype$module

   delete-vxi-registers $registerbase.*

   TGIRVXIRegisters $slot
   TGIRModuleRegisters $slot
   TGIRRegisters $module $slot

}

proc TGIRRegisters {module slot} {
   global registerbase cardtype

   set registerbase $cardtype$module.Global
   TGIRVXIRegisters $slot
   TGIRModuleRegisters  $slot


#    channel area registers 

   set c 0
   foreach segment {A B C D} {
      set registerbase $cardtype$module.BGO$segment
      TGIRDetectorRegisters  $slot $c 
      incr c
   }
}



proc tgir_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc TGIRVXIRegisters {slot} {

   tgir_register  datal          xDig "-s$slot -o0x0 -w32 -prw -fx"
   tgir_register  dataw          xDig "-s$slot -o0x0 -w16 -prw -fx"
#   tgir_register  Shtdata        xSht "-s$slot -o0x0 -w16 -prw -fx"

   tgir_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   tgir_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   tgir_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   tgir_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   tgir_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   tgir_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   tgir_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   tgir_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   tgir_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   tgir_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   tgir_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   tgir_register  VXI.Control     xSht   "-s$slot -o4  -prw -w16 -fx -b0 -l0 -i0xffc0"
   tgir_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   tgir_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}


proc TGIRModuleRegisters {slot} {
   global registerbase

#    TGIR area registers

#    Common DACs  (8 bit)

        tgir_register FT_Gate 		xDig "-s$slot -o0x800000 -w32 -pwo -fx -b0 -l8 -i15"
        tgir_register FT_Delay 		xDig "-s$slot -o0x800004 -w32 -pwo -fx -b0 -l8 -i12"
        tgir_register Valid_Gate 		xDig "-s$slot -o0x800008 -w32 -pwo -fx -b0 -l8 -i50"
        tgir_register Valid_Delay 	xDig "-s$slot -o0x80000C -w32 -pwo -fx -b0 -l8 -i40"
        tgir_register Inhibit_Gate 	xDig "-s$slot -o0x800010 -w32 -pwo -fx -b0 -l16 -i1200"

#    RM Register 0x800014  

        tgir_register RM_Reg 		xDig "-s$slot -o0x800014 -w32 -prw -fx -b0 -l11"
        tgir_register RM_Reg.valid1 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b0 -l1"
        tgir_register RM_Reg.valid2 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b1 -l1"
        tgir_register RM_Reg.syncht	xDig "-s$slot -o0x800014 -w32 -prw -fx -b2 -l1"
        tgir_register RM_Reg.gostopRM	xDig "-s$slot -o0x800014 -w32 -prw -fx -b3 -l1"
        tgir_register RM_Reg.memechRM	xDig "-s$slot -o0x800014 -w32 -prw -fx -b4 -l1"
        tgir_register RM_Reg.razRM 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b5 -l1"
        tgir_register RM_Reg.inhreqRM 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b6 -l1"
        tgir_register RM_Reg.rejectEvt 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b7 -l1"
        tgir_register RM_Reg.fincode 	xDig "-s$slot -o0x800014 -w32 -prw -fx -b8 -l1"
        tgir_register RM_Reg.finlect	xDig "-s$slot -o0x800014 -w32 -prw -fx -b9 -l1"



        tgir_register SimStartTrig 	xDig "-s$slot -o0x800018 -w32 -pwo -fx -b0 -l0"



#    DSP TGIR Control Register 0x800020

        tgir_register 	TDCR 			xDig    "-s$slot -o0x800020 -w32 -prw -fd -b0 -l0"
        tgir_register 	TDCR.DataXfer1.Enable   xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b0 -l1"
        tgir_register	TDCR.DataGIR.Enable 	xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b1 -l1"
        tgir_register 	TDCR.Link4.Enable 	xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b2 -l1"
        tgir_register 	TDCR.DMA.TEST 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b3 -l1"
        tgir_register 	TDCR.Process 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b4 -l4"
        tgir_register 	TDCR.Spectre 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b4 -l1"
        tgir_register 	TDCR.Scaler 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b5 -l1"
        tgir_register 	TDCR.bit6 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b6 -l1"
        tgir_register 	TDCR.bit7 		xDig    "-s$slot  -o0x800020 -w32 -prw -fx -b7 -l1"

#    TGIR Readout Control Register 0x800024

        tgir_register 	TRCR 			xDig    "-s$slot  -o0x800024 -w32 -prw -fd -b0 -l0"
        tgir_register 	TRCR.Enable 		xDig    "-s$slot  -o0x800024 -w32 -prw -fx -b0 -l1 -i0"
        tgir_register	TRCR.TestBoard.En 	xDig    "-s$slot  -o0x800024 -w32 -prw -fx -b1 -l1 -i0"
        tgir_register 	TRCR.FP0.En 		xDig    "-s$slot  -o0x800024 -w32 -prw -fx -b2 -l1"
        tgir_register 	TRCR.FP1.En 		xDig    "-s$slot  -o0x800024 -w32 -prw -fx -b3 -l1"
        tgir_register 	TRCR.FP2.En 		xDig    "-s$slot  -o0x800024 -w32 -prw -fx -b4 -l1 -i1"


#    TGIR Status Register 0x800028

        tgir_register 	TSR 			xDig    "-s$slot  -o0x800028 -w32 -prw -fd -b0 -l0"
        tgir_register 	TSR.InhActGIR.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b0 -l1"
        tgir_register	TSR.InhActRM.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b1 -l1"
        tgir_register	TSR.InhReqfromRM.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b2 -l1"
        tgir_register	TSR.InhReq2RM.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b3 -l1"
        tgir_register	TSR.GoStoptoRM.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b4 -l1"
        tgir_register	TSR.GoStopfromRM.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b5 -l1"
        tgir_register	TSR.ValacktoGIR.En 	xDig    "-s$slot  -o0x800028 -w32 -prw -fx -b6 -l1"

#    TGIR Reset Register 0x80002C

        tgir_register TRAZ 			xDig "-s$slot -o0x80002c -w32 -prw -fd -b0 -l0 -i0"
        tgir_register TDSP.Reset	 		xDig "-s$slot -o0x80002c -w32 -prw -fd -b0 -l1 -i0"
        tgir_register TRAZ.LCA 			xDig "-s$slot -o0x80002c -w32 -prw -fd -b1 -l1 -i0"
        tgir_register TRAZ.Board 			xDig "-s$slot -o0x80002c -w32 -prw -fd -b2 -l1 -i0"


#    TGIR APBUF Registers 0x800030 to 0x800044

        tgir_register GIR.AP1.Buf1R 	xDig 	"-s$slot -o0x800040 -w32 -pro -fx -b0 -l0 "
        tgir_register GIR.AP1.Buf2R	xDig 	"-s$slot -o0x800044 -w32 -pro -fx -b0 -l0 "
        tgir_register GIR.AP1.Buf3R 	xDig 	"-s$slot -o0x800048 -w32 -pro -fx -b0 -l15 "
        tgir_register GIR.AP2.Buf1R 	xDig 	"-s$slot -o0x80004C -w32 -pro -fx -b0 -l4 "
        tgir_register GIR.AP2.Buf2R 	xDig 	"-s$slot -o0x80004C -w32 -pro -fx -b8 -l9 "
        tgir_register GIR.AP3.Buf1R 	xDig 	"-s$slot -o0x800050 -w32 -pro -fx -b2 -l14 " 
	tgir_register GIR.AP3.Buf2R 	xDig 	"-s$slot -o0x800050 -w32 -pro -fx -b16 -l16 "
	tgir_register GIR.AP3.Buf3R 	xDig 	"-s$slot -o0x800054 -w32 -pro -fx -b0 -l15 "


#    GIR area registers


        tgir_register   MCR_GIR           xDig    "-s$slot -o0x10 -w16 -prw -fx -b0 -l0 -i0"
        tgir_register   LastCard          xDig    "-s$slot  -o0x10 -w16 -prw -fx -b0 -l1"
        tgir_register   FIFO.Reset        xDig    "-s$slot  -o0x10 -w16 -prw -fx -b1 -l1"
	tgir_register   DSP.Reset         xDig    "-s$slot  -o0x10 -w16 -prw -fx -b2 -l1 -i0"
        tgir_register   ResetGIR          xDig    "-s$slot  -o0x10 -w16 -prw -fx -b3 -l1"



        tgir_register   DSP.DAC.Adj             xDig "-s$slot -o0x14 -w16 -pwo -fx -b0 -l12 -i0x7FF"
        tgir_register   DSP.POT.Adj           xDig "-s$slot -o0x16 -w16 -pwo -fx -b0 -l8 -i0xFF"

        tgir_register Insp.D1.Channel   xMux "-s$slot -o0x810200 -w16 -prw -b0 -l16 -dTGIR -md1"
        tgir_register Insp.D1.Signal    xDig "-s$slot -o0x810220 -w16 -prw -fd -b0 -l0 -i0"
        tgir_register Insp.D2.Channel   xMux "-s$slot -o0x810240 -w16 -prw -b0 -l16 -dTGIR -md2"
        tgir_register Insp.D2.Signal    xDig "-s$slot -o0x810260 -w16 -prw -fd -b0 -l0 -i0"
        tgir_register Insp.A1.Channel   xMux "-s$slot -o0x810280 -w16 -prw -b0 -l16 -dTGIR -ma1"
        tgir_register Insp.A1.Signal    xDig "-s$slot -o0x8102A0 -w16 -prw -fd -b0 -l0 -i0"
        tgir_register Insp.A2.Channel   xMux "-s$slot -o0x8102C0 -w16 -prw -b0 -l16 -dTGIR -ma2"
        tgir_register Insp.A2.Signal    xDig "-s$slot -o0x8102E0 -w16 -prw -fd -b0 -l0 -i0"
        tgir_register Insp.V.Channel    xMux "-s$slot -o0x30 -w16 -prw -b0 -l16 -dTGIR -mv"
        tgir_register Insp.V.Signal     xDig "-s$slot -o0x32 -w16 -prw -fd -b0 -l0 -i0"

#   Temperature control registers  0x40 => 0x54

        tgir_register   GIR.TCR.ReadTemp 	xDig    "-s$slot  -o0x40 -w16 -pro -fx -b0 -l9"
        tgir_register   GIR.TCR.WriteTempHigh xDig    "-s$slot  -o0x42 -w16 -pwo -fx -b0 -l9 -i0x3c"
        tgir_register   GIR.TCR.WriteTempLow 	xDig    "-s$slot  -o0x44 -w16 -pwo -fx -b0 -l9 -i0x28"
        tgir_register   GIR.TCR.ReadTempHigh 	xDig    "-s$slot  -o0x46 -w16 -pro -fx -b0 -l9"
        tgir_register   GIR.TCR.ReadTempLow 	xDig    "-s$slot  -o0x48 -w16 -pro -fx -b0 -l9"
        tgir_register   GIR.TCR.ReadCounter 	xDig    "-s$slot  -o0x4A -w16 -pro -fx -b0 -l9"
        tgir_register   GIR.TCR.ReadSlope 	xDig    "-s$slot  -o0x4C -w16 -pro -fx -b0 -l9"
        tgir_register   GIR.TCR.StartConvert 	xDig    "-s$slot  -o0x4E -w16 -pwo -fx -b0 -l9"
        tgir_register   GIR.TCR.StopConvert 	xDig    "-s$slot  -o0x50 -w16 -pwo -fx -b0 -l9"
        tgir_register   GIR.TCR.ClearAlarm    xDig    "-s$slot  -o0x52 -w16 -pwo -fx -b5 -l2"
        tgir_register   GIR.TCR.ReadConfig.Low   xDig    "-s$slot  -o0x54 -w16 -pro -fx -b5 -l1 "
        tgir_register   GIR.TCR.ReadConfig.High  xDig    "-s$slot  -o0x54 -w16 -pro -fx -b6 -l1 "

#    GIR APBUF Registers 0x60 to 0x76 IN READ/WRITE mode 

        tgir_register GIR.AP1.Buf1W 			xDig "-s$slot -o0x60 -w32 -prw -fx -b0 -l0 -i0x0"
        tgir_register GIR.AP1.Buf2W	 		xDig "-s$slot -o0x64 -w32 -prw -fx -b0 -l0 -i0x0"
        tgir_register GIR.AP1.Buf3W 			xDig "-s$slot -o0x68 -w32 -prw -fx -b0 -l15 -i0x0"
        tgir_register GIR.AP2.Buf2W 			xDig "-s$slot -o0x70 -w16 -prw -fx -b0 -l9 -i0x0"
        tgir_register GIR.AP3.Buf1W 			xDig "-s$slot -o0x72 -w16 -prw -fx -b2 -l14 -i0x0" 
	tgir_register GIR.AP3.Buf2W 			xDig "-s$slot -o0x74 -w16 -prw -fx -b0 -l16 -i0x0"
	tgir_register GIR.AP3.Buf3W 			xDig "-s$slot -o0x76 -w16 -prw -fx -b0 -l15 -i0x0"


#    GIR registers      

        tgir_register   GIR.EvNum.Count         xDig  "-s$slot  -o0x300 -w16 -prw -fx -b0 -l0"
        if {[first [split $registerbase #]] == "$registerbase"} then {
            tgir_register   GIR.EvNum.Addr          xAdr  "-s$slot  -c0 -o0x302 -w16 -b0 -l0 -i$registerbase.GIR.EvNum"
        } else {
            tgir_register   GIR.EvNum.Addr          xDig  "-s$slot  -c0 -o0x302 -w16 -prw -fx -b0 -l0"
        }
        tgir_register   GIR.EvNum               xDig  "-s$slot  -o0x300 -w32 -pro -fx -b0 -l0"

        tgir_register   GIR.FIFO.Test           xFIT  "-s$slot  -o0x304 -w32 -prw -fx"
        tgir_register   GIR.ValAck.TimeOut      xDAC  "-s$slot -c0 -a0 -z0 -o0x30e -w16 -prw -qn -us -d0 -r0:0s,0xffff:2048000ns -i8000ns"


        tgir_register   GIR.DCR                 xDig  "-s$slot  -o0x308 -w16 -prw -fx -b0 -l0 -i0"

        tgir_register   GIR.DCR.DataXfer1.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b0 -l1"
        tgir_register   GIR.DCR.DataXfer2.Enable    xDig    "-s$slot  -o0x308 -w16 -prw -fx -b1 -l1 -i1"
        tgir_register   GIR.DCR.DSP_Enable          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b2 -l1"
        tgir_register   GIR.DCR.DMA_TEST          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b3 -l1"
        tgir_register   GIR.DCR.Process          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l4"
        tgir_register   GIR.DCR.Spectre          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b4 -l1 -i1"
        tgir_register   GIR.DCR.Scaler          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b5 -l1"
        tgir_register   GIR.DCR.bit6          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b6 -l1"
        tgir_register   GIR.DCR.bit7          xDig    "-s$slot  -o0x308 -w16 -prw -fx -b7 -l1"

        tgir_register   GIR.RCR                 xDig  "-s$slot  -o0x30a -w16 -prw -fx -b0 -l0"

        tgir_register   GIR.RCR.ValAck.TimeOutReset xDig    "-s$slot  -o0x30a -w16 -prw -fx -b0 -l1 -i1"
        tgir_register   GIR.RCR.ReadOut.Disable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b1 -l1"
        tgir_register   GIR.RCR.EvNumData.Disable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b2 -l1"
        tgir_register   GIR.RCR.QStat xDig    "-s$slot  -o0x30a -w16 -prw -fx -b3 -l1"
        tgir_register   GIR.RCR.Pipeline.Enable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b4 -l1"
        tgir_register   GIR.RCR.CommonDeadtime.Enable   xDig    "-s$slot  -o0x30a -w16 -prw -fx -b5 -l1"
        tgir_register   GIR.RCR.ExtReadout.Enable     xDig    "-s$slot  -o0x30a -w16 -prw -fx -b6 -l1"

        tgir_register   GIR.ROTSR               xDig  "-s$slot  -o0x30c -w16 -pro -fx -b0 -l0"

        tgir_register   GIR.ROTSR.Temp.Status.GIR       xDig    "-s$slot  -o0x30c -w16 -pro -fx -b0 -l2"
        tgir_register   GIR.ROTSR.Temp.Status1          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b2 -l2"
        tgir_register   GIR.ROTSR.Temp.Status2          xDig    "-s$slot  -o0x30c -w16 -pro -fx -b4 -l2"
        tgir_register   GIR.ROTSR.ValAck.TimeOut.Status xDig    "-s$slot  -o0x30c -w16 -pro -fx -b6 -l1"
        tgir_register   GIR.ROTSR.FIFO.Status           xDig    "-s$slot  -o0x30c -w16 -pro -fx -b8 -l2"

#    TGIR DSP Registers

        tgir_register GIR.TDSP.Program          xGIR "-s$slot -a0xC00010"
        tgir_register GIR.TDSP.ExtMem           bVXI "-s$slot -a0xA00000 -o0x0 -w32 -pro -fx -l64"
        tgir_register GIR.TDSP.SpectrumData     bVXI "-s$slot -a0xA00000 -o0x0 -w32 -pro -fx -l64"
        tgir_register GIR.TDSP.IntMem           bVXI "-s$slot -a0xC00000 -o0x0 -w32 -pro -fx -l64"



#    DSP registers

	tgir_register   GIR.DSP.ExtMem     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	tgir_register   GIR.DSP.IntMem     bVXI    "-s$slot  -a0x400000 -o0x0 -w32 -pro -fx -l64"
	tgir_register   GIR.DSP.SpectrumData     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	tgir_register   GIR.DSP.Program    xGIR    "-s$slot  -a0x400010 -l8192 -v4 -m0 -i/MIDAS/vxi/tcl/gir/DspLdr/5/TGIR.ldr"

	tgir_register   GIR.DSP.Control      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l0"

	tgir_register   GIR.DSP.StartDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b0 -l1"
	tgir_register   GIR.DSP.FilterMode   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b1 -l1"
	tgir_register   GIR.DSP.DSPtotcount  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b3 -l1"
	tgir_register   GIR.DSP.ResetDSP     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b4 -l1"
	tgir_register   GIR.DSP.Muxalim      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b5 -l1"
	tgir_register   GIR.DSP.PZ           xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b6 -l1"
	tgir_register   GIR.DSP.ResetMemExt  xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b7 -l1"
	tgir_register   GIR.DSP.Process      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l4"
	tgir_register   GIR.DSP.Spectre      xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b8 -l1"
	tgir_register   GIR.DSP.Scaler       xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b9 -l1"

	tgir_register   GIR.DSP.Bit10        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b10 -l1"
	tgir_register   GIR.DSP.Bit11        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b11 -l1"
	tgir_register   GIR.DSP.Bit12        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b12 -l1"
	tgir_register   GIR.DSP.Bit13        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b13 -l1"
	tgir_register   GIR.DSP.Bit14        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b14 -l1"
	tgir_register   GIR.DSP.Bit15        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b15 -l1"
	tgir_register   GIR.DSP.Bit16        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b16 -l1"
	tgir_register   GIR.DSP.Bit17        xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fx -b17 -l1"

	tgir_register   GIR.DSP.Syscon       xDig    "-s$slot  -a0x400000 -o0x0    -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.Wait         xDig    "-s$slot  -a0x400000 -o0x8    -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.DMAC7        xDig    "-s$slot  -a0x400000 -o0x74   -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.C7           xDig    "-s$slot  -a0x400000 -o0x128  -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.EC7          xDig    "-s$slot  -a0x400000 -o0x13c  -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.LCTL         xDig    "-s$slot  -a0x400000 -o0x318  -w32 -prw -fx -b0 -l0 "
	tgir_register   GIR.DSP.LCOM         xDig    "-s$slot  -a0x400000 -o0x31c  -w32 -prw -fx -b0 -l0 "

	tgir_register   GIR.DSP.Reg0         xDig    "-s$slot  -a0x400000 -o0x98000 -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.Item         xDig    "-s$slot  -a0x400000 -o0x98004 -w32 -prw -fx -b0 -l0"
	tgir_register   GIR.DSP.Reg2         xDig    "-s$slot  -a0x400000 -o0x98008 -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.Reg3         xDig    "-s$slot  -a0x400000 -o0x9800C -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.Reg4         xDig    "-s$slot  -a0x400000 -o0x98010 -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.Reg5         xDig    "-s$slot  -a0x400000 -o0x98014 -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.Reg6         xDig    "-s$slot  -a0x400000 -o0x98018 -w32 -prw -fd -b0 -l0 -i8000 "
	tgir_register   GIR.DSP.DeltaPZ      xDig    "-s$slot  -a0x400000 -o0x9801C -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.inmux        xDig    "-s$slot  -a0x400000 -o0x98080 -w32 -prw -fd -b0 -l0 "
	tgir_register   GIR.DSP.PosBit       xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b0 -l6 "
	tgir_register   GIR.DSP.NbBit        xDig    "-s$slot  -a0x400000 -o0x98084 -w32 -prw -fd -b6 -l6 "

#MEGA SWITCH LCA AREA : 0x810000 to 0x8107FC

        tgir_register   MSL.SCR		xDig  "-s$slot  -a0x810000 -o0x0 -w32 -prw -fx -b0 -l2 -i0"
        tgir_register   MSL.EDR		xDig  "-s$slot  -a0x810000 -o0x4 -w32 -prw -fx -b0 -l5 -i1"
        tgir_register   DTD.Thresh0	xDig "-s$slot -a0x810000 -o0x10 -w32 -pwo -fx -b0 -l8 -i16"
        tgir_register   DTD.Thresh1	xDig "-s$slot -a0x810000 -o0x14 -w32 -pwo -fx -b0 -l8 -i16"
        tgir_register   DTD.Thresh2	xDig "-s$slot -a0x810000 -o0x18 -w32 -pwo -fx -b0 -l8 -i16"
        tgir_register   DTD.Thresh3	xDig "-s$slot -a0x810000 -o0x1C -w32 -pwo -fx -b0 -l8 -i16"
        tgir_register   DTD.ThreshS	xDig "-s$slot -a0x810000 -o0x20 -w32 -pwo -fx -b0 -l8 -i16"

#SALTI COMMON REGISTERS AREA : 0x810800 to 0x810FFC

        tgir_register PDS_Width 		xDig "-s$slot -a0x810000 -o0x800 -w32 -pwo -fx -b0 -l8 -i0xd0"
        tgir_register PDS_Delay 		xDig "-s$slot -a0x810000 -o0x804 -w32 -pwo -fx -b0 -l8 -i0x10"
        tgir_register Val_Sample 		xDig "-s$slot -a0x810000 -o0x808 -w32 -pwo -fx -b0 -l8 -i0x80"
        tgir_register Watchdog_Sample 	xDig "-s$slot -a0x810000 -o0x80C -w32 -pwo -fx -b0 -l8 -i0xff"

        tgir_register CRC 		xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b0 -l10"
        tgir_register CRC.CloverMode 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b0 -l1 -i0"
        tgir_register CRC.StopMode 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b1 -l1"
        tgir_register CRC.SaltiRdt 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b2 -l1"
        tgir_register CRC.StartMode 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b3 -l1 -i1"
        tgir_register CRC.ScalerEn 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b4 -l1"
        tgir_register CRC.VetoMode 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b5 -l1"
        tgir_register CRC.SS.En	 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b6 -l1 -i1"
        tgir_register CRC.SSMax	 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b7 -l1 -i0"
        tgir_register CRC.InhReq	 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b8 -l1"
        tgir_register CRC.LatchScalers 	xDig "-s$slot -a0x810000 -o0x810 -w32 -prw -fx -b9 -l1"

        tgir_register SS.Counter 		xDig "-s$slot -a0x810000 -o0x824 -w32 -prw -fx -b0 -l16 -i0x0"
        tgir_register SS.Pulse 		xDig "-s$slot -a0x810000 -o0x828 -w32 -pwo -fx -b0 -l0"

        tgir_register TSRC 		xDig "-s$slot -a0x810000 -o0x82C -w32 -prw -fx -b0 -l3"
        tgir_register TSRC.CFD.En		xDig "-s$slot -a0x810000 -o0x82C -w32 -prw -fx -b0 -l1 -i0"
        tgir_register TSRC.CFD.Dir 	xDig "-s$slot -a0x810000 -o0x82C -w32 -prw -fx -b1 -l2"
        tgir_register TSRC.TSalti.Rdt 	xDig "-s$slot -a0x810000 -o0x82C -w32 -prw -fx -b3 -l1 -i1"
        tgir_register TSRC.LinkAck.En 	xDig "-s$slot -a0x810000 -o0x82C -w32 -prw -fx -b4 -l1"

	tgir_register   Scaler.Mem	bVXI "-s$slot -a0x810000 -o0x0 -w32 -pro -fx -l16"

}

proc TGIRDetectorRegisters {slot c} {

# TEST SALTI CHANNEL REGISTERS

#    RGI Area write mode

# j : increment de 0 a 3 et numero de segment
# i : offset
# l : item initial, avec group = 0
 

for {set j 0} {$j<4} {incr j} {
set i [expr $j*4]
set l [expr $j+ 8*$c]

       tgir_register   RGI.ADC.Seg.$j.w   xDig "-s$slot -c$c -a0x811000 -z0x1000 -o$i -w32 -pwo -fx -b16 -l14 -i$l"
				}


for {set j 0} {$j<4} {incr j} {
set i [expr ($j)*4+0x10]
set l [expr ($j+4)+8*$c]

        tgir_register   RGI.TDC.Seg.$j.w   xDig "-s$slot -c$c -a0x811000 -z0x1000 -o$i -w32 -pwo -fx -b16 -l14 -i$l"
				}


#    RGI Area read mode

        tgir_register   RGI.ADC.Seg.0.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x0 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.ADC.Seg.1.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x4 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.ADC.Seg.2.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x8 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.ADC.Seg.3.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0xC -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.TDC.Seg.0.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x10 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.TDC.Seg.1.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x14 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.TDC.Seg.2.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x18 -w32 -pro -fx -b0 -l0"
        tgir_register   RGI.TDC.Seg.3.r   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x1C -w32 -pro -fx -b0 -l0"

        tgir_register   FT.Delay   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x40 -w32 -pwo -fx -b0 -l8 -i0x15"

        tgir_register   CRCR	   	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b0 -l12"
        tgir_register   CRCR.ADC.En	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b0 -l4 -i1"
        tgir_register   CRCR.TDC.En	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b4 -l4 -i1"
        tgir_register   CRCR.Spare.En	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b8 -l1 -i0"
        tgir_register   CRCR.Spare.Setup	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b9 -l2"
        tgir_register   CRCR.LT.Cr	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b11 -l1 -i1"
        tgir_register   CRCR.TDC.Cr	xDig "-s$slot -c$c -a0x811000 -z0x1000 -o0x44 -w32 -prw -fx -b12 -l1 -i1"

}

proc TGIR_DAQ-setup   {args}   {
   set module [first $args]

#    only perform GIR functions for event numbered modules (stops us doing it twice per card)
#   set i [second [split $module x]]
#   set j [expr $i + 1]
#   if {[expr ($i/2)*2] != $i} then {return}

    write-vxi-register $module.ResetGIR 1
    write-vxi-register $module.ResetGIR 0


#    load DSP program  (default)
    write-vxi-register $module.DSP.Reset 1
    write-vxi-register $module.DSP.Reset 0

    modify-vxi-register $module.GIR.DSP.Program "-m 2"
    write-vxi-register  $module.GIR.DSP.Program ""
    modify-vxi-register $module.GIR.DSP.Program "-m 0"

#Perform Sliding scale reset for TEST SALTI

 set ssenablestatus($module) [read-vxi-register $module.CRC.SS.En ]
 set ssminmaxstatus($module) [read-vxi-register $module.CRC.SSMax ]
write-vxi-register $module.CRC.SS.En 0	
write-vxi-register $module.CRC.SSMax 0	
write-vxi-register $module.CRC.SSMax 1	
write-vxi-register $module.CRC.SSMax 0	
write-vxi-register $module.CRC.SSMax 1	
write-vxi-register $module.CRC.SSMax 0	

write-vxi-register $module.CRC.SS.En $ssenablestatus($module)
write-vxi-register $module.CRC.SSMax $ssminmaxstatus($module)



    insert-log "Program [read-vxi-register  $module.GIR.DSP.Program] loaded into GIR DSP in $module"

    initialise-vxi-registers TGIR.*

    insert-log "Initialised registers for TGIR"
}

proc TGIR_DAQ-reset   {args}   {

   set module [first $args]

#  flush FIFOs
    write-vxi-register $module.FIFO.Reset 0
    write-vxi-register $module.FIFO.Reset 1
    write-vxi-register $module.FIFO.Reset 0


#  reset and enable GIR FIFOs
write-vxi-register $module.GIR.FIFO.Test 0
read-vxi-register $module.GIR.FIFO.Test


# reset DSP GIR
   write-vxi-register $module.GIR.DSP.StartDSP 0
   write-vxi-register $module.GIR.DSP.ResetDSP 1


#Perform Sliding scale reset for TEST SALTI

 set ssenablestatus($module) [read-vxi-register $module.CRC.SS.En ]
 set ssminmaxstatus($module) [read-vxi-register $module.CRC.SSMax ]
write-vxi-register $module.CRC.SS.En 0	
write-vxi-register $module.CRC.SSMax 0	
write-vxi-register $module.CRC.SSMax 1	
write-vxi-register $module.CRC.SSMax 0	
write-vxi-register $module.CRC.SSMax 1	
write-vxi-register $module.CRC.SSMax 0	

write-vxi-register $module.CRC.SS.En $ssenablestatus($module)
write-vxi-register $module.CRC.SSMax $ssminmaxstatus($module)

}

proc TGIR_DAQ-halt   {args}   {
   set module [first $args]

# stop DSP GIR
   write-vxi-register $module.GIR.DSP.StartDSP 0

}

proc TGIR_DAQ-go   {args}  {   
  set module [first $args]



#    Init DAQ with GIR DSP

write-vxi-register $module.GIR.DCR.DSP_Enable 1
write-vxi-register $module.GIR.DCR.DataXfer1.Enable 1
set filter [read-vxi-register $module.GIR.DCR.DataXfer2.Enable]


#  SET ITEM = 0 FOR TGIR BGA DSP SPECTRA 

set data3 0 
write-vxi-register $module.GIR.DSP.Item $data3

 set spectraflag($module) [read-vxi-register $module.GIR.DCR.Process]
 
 write-vxi-register $module.GIR.DSP.Process $spectraflag($module)

#    start the GIR DSP
  write-vxi-register $module.GIR.DSP.FilterMode $filter
  write-vxi-register $module.GIR.DSP.StartDSP 1



}


